Subject: Re: bug#71424: 29.3; auto-revert-use-notify buggy interaction with indirect buffers

From: Eli Zaretskii <[email-masked]>
Date: Sat, 08 Jun 2024 10:03:36 +0300

> Cc: [email-masked]
> From: [email-masked]
> Date: Sat, 08 Jun 2024 00:44:13 -0400
> 
> 
> 1. emacs -Q
> 2. Enable global-auto-revert-mode, and ensure auto-revert-use-notify=t
> 3. Open an org file, such as ~/temp.org
> 4. Insert some contents:
> 
>    * example org contents
>   here is a subtree
>    * another heading
> 
> 5. Save the buffer
> 6. Outside of Emacs, modify ~/temp.org:
> 
>    $ echo asdf >> ~/temp.org
> 
> 7. See that temp.org's buffer is immediately reverted in Emacs and
>    contains the new contents that were added.
> 8. M-x org-tree-to-indirect-buffer
> 9. Kill the new indirect buffer
> 
> 10. Modify ~/temp.org outside of Emacs again.  temp.org's buffer is
>     not reverted, and even if you eval (auto-revert-buffers), the
>     buffer is not reverted.

Thanks, but did you report this to the Org developers first?  If not,
please do, so they could analyze the issue and determine whether it's
an Org bug or a bug in some core Emacs functionality.

To see that at least the basic functionality works in Emacs, I did the
following:

  emacs -Q
  C-x C-f SOME-FILE RET
  M-x global-auto-revert-mode RET
  M-x clone-indirect-buffer RET

Then, outside Emacs, typed from the shell prompt

  $ cat OTHER-FILE >> SOME-FILE

where OTHER-FILE is some other existing file.  After that, I saw both
the base buffer's text and that of its indirect clone change to
reflect the appended text.

So my conclusion is that the Subject of your bug report is not
accurate: the auto-revert feature does work with indirect buffers as
expected.  Which is why I think this might be an Org specific issue,
since org-tree-to-indirect-buffer does more than just create an
indirect buffer.

Thanks.